<?php
/** miniOrange enables user to log in through OpenID to apps such as Discord etc.
Copyright (C) 2015  miniOrange

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
 * @package 		miniOrange OAuth
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 */
/**
This library is miniOrange Authentication Service.
Contains Request Calls to Customer service.

 **/
class MoCustomerDiscordverification {

    public $email;
    public $phone;

    private $defaultCustomerKey = "16555";
    private $defaultApiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

    function create_dis_customer(){
        $url = get_option('mo_discord_integrator_host_name') . '/moas/rest/customer/add';
        $current_user = wp_get_current_user();
        $this->email 		= get_option('mo_discord_admin_email');
        $password = get_option('mo_discord_admin_password');

        $fields = array(
            'areaOfInterest' => 'WordPress Discord Integration Plugin',
            'email'		=> $this->email,
            'password'	=> $password
        );
        $field_string = wp_json_encode($fields);
        $headers = array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        if($response['body']==NULL)
        {
            if($_POST['action']=='mo_register_new_user')
                wp_send_json(["error" => 'There was an error creating an account for you. Please try again.']);
            else {
                update_option('mo_discord_message', 'There was an error creating an account for you. Please try again.');
                update_option('mo_discord_registration_status', 'error creating an account');
                mo_discord_show_error_message();
                if (get_option('regi_pop_up') == "yes") {
                    update_option('pop_regi_msg', get_option('mo_discord_message'));
                    mo_discord_registeration_modal();
                }
            }
        }
        else
            return $response['body'];
    }

    function get_dis_customer_key() {
        $url 	= get_option('mo_discord_integrator_host_name') . "/moas/rest/customer/key";
        $email 	= get_option("mo_discord_admin_email");

        $password = get_option("mo_discord_admin_password");

        $fields = array(
            'email' 	=> sanitize_email($email),
            'password' 	=> $password
        );
        $field_string = wp_json_encode( $fields );
        $headers = array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        return $response['body'];
    }

    function check_dis_customer() {
        $url 	= get_option('mo_discord_integrator_host_name') . "/moas/rest/customer/check-if-exists";
        $email 	= get_option("mo_discord_admin_email");

        $fields = array(
            'email' 	=> sanitize_email($email),
        );
        $field_string = wp_json_encode( $fields );

        $headers = array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        return $response['body'];
    }

    function get_dis_timestamp()
    {
        $url = get_option('mo_discord_integrator_host_name') . '/moas/rest/mobile/get-timestamp';
        $response = self::mo_discord_wp_remote_post($url);
        return $response['body'];
    }
    function mo_discord_send_email_alert($email,$phone,$message){

        $hostname 	= get_site_option('mo_discord_integrator_host_name') ;
        $url =  $hostname.'/moas/api/notify/send';
        $customerKey = $this->defaultCustomerKey;
        $apiKey = $this->defaultApiKey;

        $phone_number = get_option('mo_discord_admin_phone');
        $currentTimeInMillis = self::get_dis_timestamp();
        $stringToHash 		= $customerKey .  $currentTimeInMillis . $apiKey;
        $hashValue 			= hash("sha512", $stringToHash);
        $fromEmail 			= $email;
        $subject            = "miniOrange WordPress Discord Integration -".get_option('mo_discord_integrator_version')." : ".$email;
        $site_url=site_url();
        $activation_date=get_option('mo_discord_user_activation_date1');
        $deactivationdate = date("Y-m-d");
        $version = get_option('mo_discord_integrator_version');
        $store_activation= strtotime($activation_date);
        $store_deactivation=  strtotime($deactivationdate);
        $diff = $store_deactivation-$store_activation;
        $total_activation_days= abs(round($diff / 86400));
        global $user;
        $user= wp_get_current_user();


        $query =" miniOrange WordPress Discord Integration";
        $content='<div >Hello, <br><br>First Name :<br><br>Last  Name :
								<br><br>Company : '.sanitize_text_field($_SERVER['HTTP_HOST']).'
								<br><br>Phone Number : '.$phone_number.'
								<br><br>Email : <a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a>
								<br><br>Activation time : '.$activation_date.' - '.$deactivationdate.'  ['.$total_activation_days.']
								<br><br>Plugin Deactivated: '.$query.''. $version.'
								<br><br>Reason: <b>'.$message.'</b></div>';


        $fields = array(
            'customerKey'	=> $customerKey,
            'sendEmail' 	=> true,
            'email' 		=> array(
                'customerKey' 	=> $customerKey,
                'fromEmail' 	=> $fromEmail,
                'bccEmail' 		=> 'discordsupport@xecurify.com',
                'fromName' 		=> 'miniOrange',
                'toEmail' 		=> 'discordsupport@xecurify.com',
                'toName' 		=> 'discordsupport@xecurify.com',
                'subject' 		=> $subject,
                'content' 		=> $content
            ),
        );
        $field_string = wp_json_encode($fields);


        $headers = array(
            "Content-Type" => "application/json",
            "Customer-Key" => $customerKey,
            "Timestamp" => $currentTimeInMillis,
            "Authorization" => $hashValue
        );
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        $response['body'] = isset($response['body']) ? $response['body'] : '';
        return $response['body'];

    }
    function mo_dis_submit_rate_us($email, $query){

        $query = 'Star Rating:'.get_option('mo_discord_rating_given').' '.$query;
        $hostname 	= get_site_option('mo_discord_integrator_host_name') ;
        $url =  $hostname.'/moas/api/notify/send';
        $customerKey = $this->defaultCustomerKey;
        $apiKey = $this->defaultApiKey;

        $currentTimeInMillis = self::get_dis_timestamp();
        $stringToHash 		= $customerKey .  $currentTimeInMillis . $apiKey;
        $hashValue 			= hash("sha512", $stringToHash);
        $fromEmail 			= $email;
        $subject            = "miniOrange WordPress Discord Integration Rate us Feedback: ".$email;
        $site_url=site_url();

        global $user;
        $user= wp_get_current_user();

        $content='<div >Hello,  <br><br>First Name :
								<br><br>Last  Name :
								<br><br>Company :
								<br><br><b>Email :<a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a></b>
								<br><br><b>Reason: '.$query.'</b></div>';


        $fields = array(
            'customerKey'	=> $customerKey,
            'sendEmail' 	=> true,
            'email' 		=> array(
                'customerKey' 	=> $customerKey,
                'fromEmail' 	=> $fromEmail,
                'bccEmail' 		=> 'discordsupport@xecurify.com',
                'fromName' 		=> 'miniOrange',
                'toEmail' 		=> 'discordsupport@xecurify.com',
                'toName' 		=> 'discordsupport@xecurify.com',
                'subject' 		=> $subject,
                'content' 		=> $content
            ),
        );
        $field_string = wp_json_encode($fields);


        $headers = array(
            "Content-Type" => "application/json",
            "Customer-Key" => $customerKey,
            "Timestamp" => $currentTimeInMillis,
            "Authorization" => $hashValue
        );
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        return $response['body'];
    }
    function mo_dis_submit_contact_us($email, $phone, $query, $feature_plan ) {
        $url = get_option('mo_discord_integrator_host_name') . '/moas/rest/customer/contact-us';
        $current_user = wp_get_current_user();
        $company = get_option('mo_discord_admin_company_name') ? get_option('mo_discord_admin_company_name') : sanitize_text_field($_SERVER ['SERVER_NAME']);
        $first_name = get_option('mo_discord_admin_first_name') ? get_option('mo_discord_admin_first_name') : $current_user->user_firstname;
        $last_name = get_option('mo_discord_admin_last_name') ? get_option('mo_discord_admin_last_name') : $current_user->user_lastname;
        $query = '[WordPress Discord Integration Plugin Version: '.get_option('mo_discord_integrator_version').'] ' .$feature_plan.":".$query;
        $fields = array(
            'firstName'			=> $first_name,
            'lastName'	 		=> $last_name,
            'company' 			=> $company,
            'email' 			=> $email,
            'ccEmail'           => 'discordsupport@xecurify.com',
            'phone'				=> $phone,
            'query'				=> $query
        );
        $field_string = wp_json_encode( $fields );
        $headers = array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '10',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        return $response['body'];
    }

    function mo_dis_forgot_password($email){

        $url = get_option('mo_discord_integrator_host_name') . '/moas/rest/customer/password-reset';
        /* The customer Key provided to you */
        $customerKey = get_option('mo_discord_admin_customer_key');

        /* The customer API Key provided to you */
        $apiKey = get_option('mo_discord_admin_api_key');

        /* Current time in milliseconds since midnight, January 1, 1970 UTC. */
        $currentTimeInMillis = round ( microtime ( true ) * 1000 );
        $stringToHash = $customerKey . number_format ( $currentTimeInMillis, 0, '', '' ) . $apiKey;
        $hashValue = hash("sha512", $stringToHash);

        $fields = '';

        $fields = array(
            'email' => $email
        );

        $field_string = wp_json_encode($fields);

        $headers = array(
            "Content-Type" => "application/json",
            "Customer-Key" => $customerKey,
            "Timestamp" => $currentTimeInMillis,
            "Authorization" => $hashValue
        );
        $args = array(
            'method' => 'POST',
            'body' => $field_string,
            'timeout' => '5',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => $headers
        );
        $response = self::mo_discord_wp_remote_post($url, $args);
        return $response['body'];
    }

    function mo_discord_wp_remote_post($url, $args = array()){
        $check_action=isset($_POST['action']) ? esc_attr($_POST['action']) : '';
        $response = wp_remote_post($url, $args);
        if(!is_wp_error($response)){
            return $response;
        } else {
            if ($check_action == 'mo_register_new_user')
                wp_send_json(["error" => 'Unable to connect to the Internet. Please try again.']);
            else {
                update_option('mo_discord_message', 'Unable to connect to the Internet. Please try again.');
                mo_discord_success_message();
            }
        }
    }

}