<?php
include "mo-discord-login-functions.php";
add_action( 'wp_login', 'mo_discord_link_account', 5, 2);
add_action('wp_login', 'mo_discord_login_redirect', 11, 2);
add_action( 'mo_user_register','mo_discord_update_role',1, 2 );
add_action( 'delete_user', 'mo_discord_delete_account_linking_rows' );
add_action('widgets_init', function () {
    register_widget("mo_discord_login_wid");
});

class mo_discord_login_wid extends WP_Widget {
    public function __construct() {
        parent::__construct(
            'mo_discord_login_wid',
            'miniOrange Discord Login Widget',
            array(
                'description' => __( 'Login using Discord', 'flw' ),
                'customize_selective_refresh' => true,
            )
        );
    }

    public function widget( $args, $instance ) {
        extract( $args );
        $allowed_html= array('div'=>array(),'class'=>array());
        echo wp_kses($args['before_widget'],$allowed_html);
        $this->discordloginForm();

        echo wp_kses($args['after_widget'],$allowed_html);
    }

    public function update( $new_instance, $old_instance ) {
        $instance = array();
        $instance['wid_title'] = strip_tags( $new_instance['wid_title'] );
        return $instance;
    }


    public function discordloginForm(){
        $selected_theme = esc_attr(get_option('mo_discord_login_theme'));
        $appsConfigured = esc_attr(get_option('mo_discord_enable'));
        $spacebetweenicons = esc_attr(get_option('mo_login_icon_space'));
        $customWidth = esc_attr(get_option('mo_login_icon_custom_width'));
        $customHeight = esc_attr(get_option('mo_login_icon_custom_height'));
        $customSize = esc_attr(get_option('mo_login_icon_custom_size'));
        $customBackground = esc_attr(get_option('mo_login_icon_custom_color'));
        $customTheme = esc_attr(get_option('mo_discord_login_custom_theme'));
        $customTextofTitle = esc_attr(get_option('mo_discord_login_button_customize_text'));
        $customBoundary = esc_attr(get_option('mo_login_icon_custom_boundary'));
        $customLogoutName = esc_attr(get_option('mo_discord_login_widget_customize_logout_name_text'));
        $customLogoutLink = esc_attr(get_option('mo_discord_login_widget_customize_logout_text'));
        $customTextColor=esc_attr(get_option('mo_login_discord_login_widget_customize_textcolor'));
        $customText=esc_html(get_option('mo_discord_login_widget_customize_text'));
        $application_pos = esc_attr(get_option('app_pos'));

        $protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
        $sign_up_url = $protocol . sanitize_text_field($_SERVER['HTTP_HOST']) . sanitize_url($_SERVER['REQUEST_URI']);
        $mo_URL=strstr($sign_up_url, "?", true);
        if($mo_URL) {
            setcookie("mo_discord_signup_url",  $mo_URL, time() + (86400 * 30), "/");}
        else{
            setcookie("mo_discord_signup_url", $sign_up_url, time() + (86400 * 30), "/");}

        if( ! is_user_logged_in() ) {
            $values=array(
                'appsConfigured' => $appsConfigured,
                'selected_apps' => '',
                'application_pos' => $application_pos,
                'customTextColor' => $customTextColor,
                'customText' => $customText,
                'selected_theme' => $selected_theme,
                'view' => '',
                'spacebetweenicons' => $spacebetweenicons,
                'customWidth' => $customWidth,
                'customHeight' => $customHeight,
                'customBoundary' => $customBoundary,
                'buttonText' => $customTextofTitle,
                'customTextofTitle' => $customTextofTitle,
                'customSize' => $customSize,
                'html' => '',
                'customBackground' => $customBackground,
                'customTheme' => $customTheme,
            );
            $html=$this->mo_discord_display_apps($values);
            $html.='<br/>';
            $plugins_allowedtags1 =array('div'=> array('class'=>array()),'p'=>array('style'=>array()),'a'=>array('rel'=>array(),'style'=>array(),'class'=>array(),'onclick'=>array()),'i'=>array('style'=>array(),'class'=>array()));
            echo (wp_kses($html,$plugins_allowedtags1));
        }
        else {
            global $current_user;
            $current_user = wp_get_current_user();
            $customLogoutName = str_replace('##username##', $current_user->display_name, $customLogoutName);
            $link_with_username = $customLogoutName;
            if (empty($customLogoutName)  || empty($customLogoutLink)) {
                ?>
                <div id="logged_in_user" class="mo_discord_login_wid">
                    <li><?php echo esc_attr($link_with_username);?> <a href="<?php echo esc_url(wp_logout_url( site_url()) ); ?>" title="<?php esc_attr_e('Logout','flw');?>"><?php esc_attr_e($customLogoutLink,'flw');?></a></li>
                </div>
                <?php
            }
            else {
                ?>
                <div id="logged_in_user" class="mo_discord_login_wid">
                    <li><?php echo esc_attr($link_with_username);?> <a href="<?php echo esc_url(wp_logout_url( site_url()) ); ?>" title="<?php esc_attr(_e('Logout','flw'));?>"><?php esc_attr_e($customLogoutLink,'flw');?></a></li>
                </div>
                <?php
            }
        }
    }


    public function if_discord_custom_app_exists($app_name){

        if(get_option('mo_discord_login_app'))
        {
            $appslist = maybe_unserialize(get_option('mo_discord_login_app'));
            if(isset($appslist[$app_name])) {
                if (get_option('mo_discord_enable_custom_app_' . $app_name))
                    return 'true';
                else
                    return 'false';
            }
            else
                return 'false';
        }
        return 'false';
    }

    public function discordloginFormShortCode( $atts ){
        global $post;
        $html = '';
        $apps="";
        $selected_theme = isset( $atts['shape'] )? esc_attr($atts['shape']) : esc_attr(get_option('mo_discord_login_theme'));
        $selected_apps = isset( $atts['apps'] )? esc_attr($atts['apps']) : "";
        $application_pos = esc_attr(get_option('app_pos'));
        $appsConfigured = esc_attr(get_option('mo_discord_enable'));
        $spacebetweenicons = isset( $atts['space'] )? esc_attr(intval($atts['space'])) : esc_attr(intval(get_option('mo_login_icon_space')));
        $customWidth = isset( $atts['width'] )? esc_attr(intval($atts['width'])) : esc_attr(intval(get_option('mo_login_icon_custom_width')));
        $customHeight = isset( $atts['height'] )? esc_attr(intval($atts['height'])) : esc_attr(intval(get_option('mo_login_icon_custom_height')));
        $customSize = isset( $atts['size'] )? esc_attr(intval($atts['size'])) : esc_attr(intval(get_option('mo_login_icon_custom_size')));
        $customBackground = isset( $atts['background'] )? esc_attr($atts['background']) : esc_attr(get_option('mo_login_icon_custom_color'));
        $customTheme = isset( $atts['theme'] )? esc_attr($atts['theme']) : esc_attr(get_option('mo_discord_login_custom_theme'));
        $buttonText = esc_html(get_option('mo_discord_login_button_customize_text'));
        $customTextofTitle = esc_attr(get_option('mo_discord_login_button_customize_text'));
        $logoutUrl = esc_url(wp_logout_url(site_url()));
        $customBoundary = isset( $atts['edge'] )? esc_attr($atts['edge']) : esc_attr(get_option('mo_login_icon_custom_boundary'));
        $customLogoutName = esc_attr(get_option('mo_discord_login_widget_customize_logout_name_text'));
        $customLogoutLink = get_option('mo_discord_login_widget_customize_logout_text');
        $customTextColor= isset( $atts['color'] )? esc_attr($atts['color']) : esc_attr(get_option('mo_login_discord_login_widget_customize_textcolor'));
        $customText=isset( $atts['heading'] )? esc_html($atts['heading']) :esc_html(get_option('mo_discord_login_widget_customize_text'));
        $view=isset( $atts['view'] )? esc_attr($atts['view']) : "";
        $appcnt=isset( $atts['appcnt'] )? esc_attr($atts['appcnt']) : "";
        if($selected_theme == 'longbuttonwithtext'){
            $selected_theme = 'longbutton';
        }

        if($customTheme == 'custombackground'){
            $customTheme = 'custom';
        }


        $protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
        $sign_up_url = $protocol . sanitize_text_field($_SERVER['HTTP_HOST']) . sanitize_url($_SERVER['REQUEST_URI']);
        $mo_URL=strstr($sign_up_url, "?", true);
        if($mo_URL) {setcookie("mo_discord_signup_url",  $mo_URL, time() + (86400 * 30), "/");}
        else{setcookie("mo_discord_signup_url", $sign_up_url, time() + (86400 * 30), "/");}
        if( ! is_user_logged_in() ) {

            $values=array(
                'appsConfigured' => $appsConfigured,
                'selected_apps' => $selected_apps,
                'application_pos' => $application_pos,
                'customTextColor' => $customTextColor,
                'customText' => $customText,
                'selected_theme' => $selected_theme,
                'view' => $view,
                'spacebetweenicons' => $spacebetweenicons,
                'customWidth' => $customWidth,
                'customHeight' => $customHeight,
                'customBoundary' => $customBoundary,
                'buttonText' => $buttonText,
                'customTextofTitle' => $customTextofTitle,
                'customSize' => $customSize,
                'html' => $html,
                'customBackground' => $customBackground,
                'customTheme' => $customTheme,
                'appcnt' => $appcnt,
            );
            $html=$this->mo_discord_display_apps($values);

        }else {
            global $current_user;
            $current_user = wp_get_current_user();
            $customLogoutName = str_replace('##username##', $current_user->display_name, $customLogoutName);
            $flw = __($customLogoutLink,"flw");
            if (empty($customLogoutName)  || empty($customLogoutLink)) {
                $html .= '<div id="logged_in_user" class="mo_discord_login_wid">' . $customLogoutName . ' <a href=' . $logoutUrl .' title=" ' . $flw . '"> ' . $flw . '</a></div>';
            }
            else {
                $html .= '<div id="logged_in_user" class="mo_discord_login_wid">' . $customLogoutName . ' <a href=' . $logoutUrl .' title=" ' . $flw . '"> ' . $flw . '</a></div>';
            }
        }
        return $html;
    }

    public function mo_discord_display_apps($values){
        $appsConfigured=esc_attr($values['appsConfigured']);
        $selected_apps=esc_attr($values['selected_apps']);
        $application_pos=esc_attr($values['application_pos']);
        $customTextColor=esc_attr($values['customTextColor']);
        $customText=esc_attr($values['customText']);
        $spacebetweenicons=esc_attr($values['spacebetweenicons']);
        $customWidth=esc_attr($values['customWidth']);
        $customHeight=esc_attr($values['customHeight']);
        $customBoundary=esc_attr($values['customBoundary']);
        $buttonText=esc_attr($values['buttonText']);
        $customTextofTitle=esc_attr($values['customTextofTitle']);
        $customSize=esc_attr($values['customSize']);
        $selected_theme=esc_attr($values['selected_theme']);
        $html=esc_html($values['html']);
        $view=esc_attr($values['view']);
        $customBackground=esc_attr($values['customBackground']);
        $customTheme=esc_attr($values['customTheme']);
        $appcnt=isset($values['appcnt'])?esc_attr($values['appcnt']):'';

        if( $appsConfigured || $selected_apps!="") {

            if($selected_apps!="")
                $apps=explode(',', $selected_apps);
            else
                $apps=explode('#', $application_pos);

            $this->mo_discord_load_login_script();
            $html .= "<div class='mo-discord-app-icons'>
					 <p style='color:".$customTextColor."; width: fit-content;'> $customText</p>";
            $count = -1;
            if($selected_apps!=""){
                if(mo_discord_is_customer_registered())
                {
                    foreach ($apps as $select_apps) {
                        if ($selected_theme == 'longbutton') {
                            if ($view == "horizontal" && isset($appcnt)) {
                                $count++;
                                if ("".$count == "".$appcnt) {
                                    $html .= "<br/>";
                                    $count = 0;
                                }
                            }
                        }
                        $app_values= array(
                            'spacebetweenicons' => $spacebetweenicons,
                            'customWidth' => $customWidth,
                            'customHeight' => $customHeight,
                            'customBoundary' => $customBoundary,
                            'buttonText' => $buttonText,
                            'customTextofTitle' => $customTextofTitle,
                            'customSize' => $customSize,
                            'selected_theme' => $selected_theme,
                            'html' => $html,
                            'view' => $view,
                            'customBackground' => $customBackground,
                            'customTheme' => $customTheme,
                            'customer_register' => 'yes',
                        );
                        $html=$this->mo_discord_select_app($select_apps,$app_values);
                    }
                }
                else{
                    foreach ($apps as $select_apps) {
                        if ($selected_theme == 'longbutton') {
                            if ($view == "horizontal" && isset($appcnt)) {
                                $count++;
                                if ($count == $appcnt) {
                                    $html .= "<br/>";
                                    $count = 0;
                                }
                            }
                        }
                        $app_values= array(
                            'spacebetweenicons' => $spacebetweenicons,
                            'customWidth' => $customWidth,
                            'customHeight' => $customHeight,
                            'customBoundary' => $customBoundary,
                            'buttonText' => $buttonText,
                            'customTextofTitle' => $customTextofTitle,
                            'customSize' => $customSize,
                            'selected_theme' => $selected_theme,
                            'html' => $html,
                            'view' => $view,
                            'customBackground' => $customBackground,
                            'customTheme' => $customTheme,
                            'customer_register' => 'no',
                        );
                        $html=$this->mo_discord_select_app($select_apps,$app_values);
                    }
                }
            }
            else{
                foreach ($apps as $select_apps) {
                    if (get_option('mo_'.$select_apps.'_enable')) {
                        if ($selected_theme == 'longbutton') {
                            if ($view == "horizontal" && isset($appcnt)) {
                                $count++;
                                if ($count == $appcnt) {
                                    $html .= "<br/>";
                                    $count = 0;
                                }
                            }
                        }
                        $app_values= array(
                            'spacebetweenicons' => $spacebetweenicons,
                            'customWidth' => $customWidth,
                            'customHeight' => $customHeight,
                            'customBoundary' => $customBoundary,
                            'buttonText' => $buttonText,
                            'customTextofTitle' => $customTextofTitle,
                            'customSize' => $customSize,
                            'selected_theme' => $selected_theme,
                            'html' => $html,
                            'view' => $view,
                            'customBackground' => $customBackground,
                            'customTheme' => $customTheme,
                            'customer_register' => 'yes',
                        );
                        $html=$this->mo_discord_select_app($select_apps,$app_values);
                    }
                }
            }
            $html .= '</div> <br>';
        }
        else {
            $html .= '<div>No apps configured. Please contact your administrator.</div>';
        }
        return $html;
    }

    public function mo_discord_select_app($select_apps,$app_values){
        if( get_option('mo_discord_fonawesome_load') == 1)
            wp_enqueue_style( 'mo-discord-sl-wp-font-awesome',plugins_url('includes/css/mo-font-awesome.min.css', __FILE__), false );
        wp_enqueue_style( 'mo-wp-style-icon',plugins_url('includes/css/mo_discord_login_icons.css', __FILE__), false );
        wp_enqueue_style( 'mo-wp-bootstrap-social',plugins_url('includes/css/bootstrap-discord.css', __FILE__), false );
        if( get_option('mo_discord_bootstrap_load') == 1)
            wp_enqueue_style( 'mo-wp-bootstrap-main',plugins_url('includes/css/bootstrap.min-preview.css', __FILE__), false );

        $spacebetweenicons = $app_values['spacebetweenicons'];
        $customWidth = $app_values['customWidth'];
        $customHeight = $app_values['customHeight'];
        $customBoundary = $app_values['customBoundary'];
        $buttonText = $app_values['buttonText'];
        $customTextofTitle = $app_values['customTextofTitle'];
        $customSize = $app_values['customSize'];
        $selected_theme = $app_values['selected_theme'];
        $html = $app_values['html'];
        $view = $app_values['view'];
        $customBackground = $app_values['customBackground'];
        $customTheme = $app_values['customTheme'];
        switch ($select_apps) {

            case 'discord':
                $custom_app = esc_attr($this->if_discord_custom_app_exists('discord'));
                $custom_app == "false" ? $app_dis = "disable" : $app_dis = "";
                $html = $this->mo_discord_add_apps("discord", $customTheme, $spacebetweenicons, $customWidth, $customHeight, $customBoundary, $buttonText, $customTextofTitle, $customSize, $selected_theme, $custom_app, $html, $view, $customBackground, $app_dis);
                break;
        }
        return $html;
    }

    public function mo_discord_add_apps($app_name,$theme,$spacebetweenicons,$customWidth,$customHeight,$customBoundary,$buttonText,$customTextofTitle,$customSize,$selected_theme,$custom_app,$html,$view,$customBackground,$app_dis)
    {
        $default_color= array('discord'=>'#7289da');

        if($customWidth!=='auto'||$customWidth=='Auto'||$customWidth=='AUTO')
            $customWidth.='px';
        if($theme=="default")
        {
            if($app_name=="discord")
            {
                if ($selected_theme == 'longbutton') {
                    $html .= "<a style='margin-left: " . $spacebetweenicons . "px !important;width: " . $customWidth . " !important;padding-top:" . ($customHeight - 29) . "px !important;padding-bottom:" . ($customHeight - 29) . "px !important;margin-bottom: " . ($spacebetweenicons) . "px !important;border-radius: " . $customBoundary . "px !important;' class='mo_btn mo_btn-mo mo_btn-block mo_btn-social mo_btn-discord mo_btn-custom-dec login-button' onClick=\"moDiscordLogin('discord','" . $custom_app . "');\" rel='nofollow'";
                    $html.="> <i style='padding-top:" . ($customHeight - 35) . "px !important' class='fab fa-discord'></i>" . $buttonText . " discord</a>";
                } else {
                    $html .= "<a class='login-button' rel='nofollow' title= ' " . $customTextofTitle . " discord'"; if($app_dis!="disable") $html.=" onClick=\"moDiscordLogin('discord','" . $custom_app . "');\""; $html.=" title= ' " . $customTextofTitle . "  discord'><i style='margin-top:10px;width:" . $customSize . "px !important;height:" . $customSize . "px !important;margin-left:" . ($spacebetweenicons) . "px !important;background:".$default_color['discord'].";font-size: " . ($customSize - 16) . "px !important;text-align:center; padding-top: 8px;color:white'  class='fab fa-discord  mo_btn-mo mo_discord-login-button login-button " . $selected_theme . "' ></i></a>";
                }
                return $html;
            }
        }

    }

    private function mo_discord_load_login_script() {
        wp_enqueue_script( 'js-cookie-script',plugins_url('includes/js/mo_discord_jquery.cookie.min.js', __FILE__), array('jquery'));
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function () {
                jQuery(".login-button").css("cursor", "pointer");
            });
            var perfEntries = performance.getEntriesByType("navigation");

            if (perfEntries[0].type === "back_forward") {
                location.reload(true);
            }
            function HandlePopupResult(result) {
                window.location = "<?php echo esc_url(mo_discord_get_redirect_url());?>";
            }
            function moDiscordLogin(app_name,is_custom_app) {
                var current_url = window.location.href;
                var cookie_name = "redirect_current_url";
                var d = new Date();
                d.setTime(d.getTime() + (2 * 24 * 60 * 60 * 1000));
                var expires = "expires="+d.toUTCString();
                document.cookie = cookie_name + "=" + current_url + ";" + expires + ";path=/";

                <?php
                if(isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off'){
                    $http = "https://";
                } else {
                    $http =  "http://";
                }
                ?>
                var base_url = '<?php echo esc_url(site_url());?>';
                var request_uri = '<?php echo esc_url($_SERVER['REQUEST_URI']);?>';
                var http = '<?php echo esc_attr($http);?>';
                var http_host = '<?php echo esc_attr($_SERVER['HTTP_HOST']);?>';
                var default_nonce = '<?php echo esc_attr(wp_create_nonce( 'mo-discord-get-social-login-nonce' )); ?>';
                var custom_nonce = '<?php echo esc_attr(wp_create_nonce( 'mo-discord-oauth-app-nonce' )); ?>';
                    if ( request_uri.indexOf('wp-login.php') !=-1){
                        var redirect_url = base_url + '/?option=oauthredirect&wp_nonce=' + custom_nonce + '&app_name=';

                    }else {
                        var redirect_url = http + http_host + request_uri;
                        if(redirect_url.indexOf('?') != -1)
                            redirect_url = redirect_url +'&option=oauthredirect&wp_nonce=' + custom_nonce + '&app_name=';
                        else
                            redirect_url = redirect_url +'?option=oauthredirect&wp_nonce=' + custom_nonce + '&app_name=';
                    }

                window.location.href = redirect_url + app_name;
            }
        </script>
        <?php
    }
}

function mo_discord_get_redirect_url() {
    $current_url = isset($_COOKIE["redirect_current_url"]) ? sanitize_url($_COOKIE["redirect_current_url"]):get_option('siteurl');
    $pos = strpos($_SERVER['REQUEST_URI'], '/disidcallback');

    $redirect_url = site_url();

    return $redirect_url;
}


function mo_discord_login_validate(){
   if( isset($_POST['mo_discord_go_back_registration_nonce']) and isset( $_POST['option'] ) and $_POST['option'] == "mo_discord_go_back_registration" ){
        $nonce = sanitize_text_field($_POST['mo_discord_go_back_registration_nonce']);
        if ( ! wp_verify_nonce( $nonce, 'mo-discord-go-back-register-nonce' ) ) {
            wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
        } else {
            update_option('mo_discord_verify_customer','true');
        }
    }

    else if( isset($_POST['mo_discord_go_back_login_nonce']) and isset( $_POST['option'] ) and $_POST['option'] == "mo_discord_go_back_login" ){
        $nonce = sanitize_text_field($_POST['mo_discord_go_back_login_nonce']);
        if ( ! wp_verify_nonce( $nonce, 'mo-discord-go-back-login-nonce' ) ) {
            wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
        } else {
            update_option('mo_discord_registration_status','');
            delete_option('mo_discord_admin_email');
            delete_option('mo_discord_admin_phone');
            delete_option('mo_discord_admin_password');
            delete_option('mo_discord_admin_customer_key');
            delete_option('mo_discord_verify_customer');
        }
    }
    else if(isset($_POST['mo_discord_forgot_password_nonce']) and isset($_POST['option']) and $_POST['option'] == 'mo_discord_forgot_password'){
        $nonce = sanitize_text_field($_POST['mo_discord_forgot_password_nonce']);
        if ( ! wp_verify_nonce( $nonce, 'mo-discord-forgot-password-nonce' ) ) {
            wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
        } else {
            $email ='';
            if( mo_discord_check_empty_or_null( $email ) ) {
                if( mo_discord_check_empty_or_null( $_POST['email'] ) ) {
                    update_option( 'mo_discord_message', 'No email provided. Please enter your email below to reset password.');
                    mo_discord_show_error_message();
                    return;
                } else {
                    $email = sanitize_email($_POST['email']);
                }
            }
            $customer = new MoCustomerDiscordverification();
            $content = json_decode($customer->mo_dis_forgot_password($email),true);
            if(strcasecmp($content['status'], 'SUCCESS') == 0){
                update_option( 'mo_discord_message','You password has been reset successfully. Please enter the new password sent to your registered mail here.');
                mo_discord_show_success_message();
            }else{
                update_option( 'mo_discord_message','An error occurred while processing your request. Please make sure you are registered in miniOrange with the <b>'. $content['email'] .'</b> email address. ');
                mo_discord_show_error_message();
            }
        }
    }
    else if( isset($_POST['mo_discord_connect_register_nonce']) and isset( $_POST['option'] ) and $_POST['option'] == "mo_discord_connect_register_customer" ) {	//register the admin to miniOrange
        $nonce = sanitize_text_field($_POST['mo_discord_connect_register_nonce']);
        if ( ! wp_verify_nonce( $nonce, 'mo-discord-connect-register-nonce' ) ) {
            wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
        } else {
            mo_discord_register_user();
        }
    }
    else if ( isset( $_REQUEST['option'] ) and strpos( $_REQUEST['option'], 'oauthredirect' ) !== false ) {
        if(isset($_REQUEST['wp_nonce'])){
            $nonce = sanitize_text_field($_REQUEST['wp_nonce']);
            if ( ! wp_verify_nonce( $nonce, 'mo-discord-oauth-app-nonce' ) ) {
                wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
            }
            else {
                $appname = sanitize_text_field($_REQUEST['app_name']);
                mo_discord_custom_app_oauth_redirect($appname);
            }
        }
    }

    else if( isset($_POST['mo_discord_connect_verify_nonce']) and isset( $_POST['option'] ) and $_POST['option'] == "mo_discord_connect_verify_customer" ) {
        $nonce = sanitize_text_field($_POST['mo_discord_connect_verify_nonce']);
        if (!wp_verify_nonce($nonce, 'mo-discord-connect-verify-nonce')) {
            wp_die('<strong>ERROR</strong>: Please Go back and Refresh the page and try again!<br/>If you still face the same issue please contact your Administrator.');
        }
        else {
            mo_discord_register_old_user();
        }
    }
    else if( strpos( $_SERVER['REQUEST_URI'], "disidcallback") !== false ||((strpos( $_SERVER['REQUEST_URI'], "oauth_token")!== false)&&(strpos( $_SERVER['REQUEST_URI'], "oauth_verifier") ))) {
        mo_discord_process_custom_app_callback();
    }
}

function get_current_discord_customer(){
    $customer = new MoCustomerDiscordverification();
    $content = $customer->get_dis_customer_key();
    $customerKey = json_decode( $content, true );
    if( isset($customerKey) ) {
        update_option( 'mo_discord_admin_customer_key', $customerKey['id'] );
        update_option( 'mo_discord_admin_api_key', $customerKey['apiKey'] );
        update_option( 'mo_discord_customer_token', $customerKey['token'] );
        update_option('mo_discord_admin_password', '' );
        update_option( 'mo_discord_message', 'Your account has been retrieved successfully.' );
        delete_option('mo_discord_verify_customer');
        delete_option('mo_discord_new_registration');
        if($_POST['action']=='mo_register_new_user')
            wp_send_json(["success" => 'Your account has been retrieved successfully.']);
        else
            mo_discord_show_success_message();
    } else {
        update_option( 'mo_discord_message', 'You already have an account with miniOrange. Please enter a valid password.');
        update_option('mo_discord_verify_customer', 'true');
        delete_option('mo_discord_new_registration');
        if($_POST['action']=='mo_register_new_user')
            wp_send_json(["error" => 'You already have an account with miniOrange. Please enter a valid password.']);
        else {
            mo_discord_show_error_message();
        }
    }
}

function mo_discord_login_redirect($username = '', $user = NULL){
    mo_discord_start_session();
    if(is_string($username) && $username && is_object($user) && !empty($user->ID) && ($user_id = $user->ID) && isset($_SESSION['mo_login']) && $_SESSION['mo_login']){
        $_SESSION['mo_login'] = false;
        wp_set_auth_cookie( $user_id, true );
        $redirect_url = mo_discord_get_redirect_url();
        wp_safe_redirect($redirect_url);
        exit;
    }
}

function mo_discord_link_account( $username, $user ){
    if($user){
        $userid = $user->ID;
    }
    mo_discord_start_session();

    $user_email =  isset($_SESSION['user_email']) ? sanitize_email($_SESSION['user_email']):'';
    $social_app_identifier = isset($_SESSION['social_user_id']) ? sanitize_text_field($_SESSION['social_user_id']):'';
    $social_app_name = isset($_SESSION['social_app_name']) ? sanitize_text_field($_SESSION['social_app_name']):'';
    if(empty($user_email)){
        $user_email=$user->user_email;
    }
    if(isset($userid) && empty($social_app_identifier) && empty($social_app_name) ) {
        return;
    }
    elseif(!isset($userid)){
        return;
    }

    global $wpdb;
    $db_prefix = $wpdb->prefix;
    $linked_email_id = $wpdb->get_var($wpdb->prepare("SELECT user_id FROM ".$db_prefix."mo_discord_linked_user where linked_email = \"%s\" AND linked_social_app = \"%s\"",$user_email,$social_app_name));
    if(!isset($linked_email_id)){
        mo_discord_insert_query($social_app_name,$user_email,$userid,$social_app_identifier);
    }
}

function mo_discord_update_role($user_id='', $user_url=''){
        if (get_option('mo_dis_basic_role_mapping')) {
            $user = get_user_by('ID', $user_id);
            $user->set_role(get_option('mo_dis_basic_role_mapping'));
        }
}


